/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 21 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"


#include "ac_cfg.h"

#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <errno.h>

#include "avrdude.h"
#include "libavrdude.h"
#include "config.h"
#include "developer_opts.h"

#if defined(WIN32)
#define strtok_r( _s, _sep, _lasts ) \
    ( *(_lasts) = strtok( (_s), (_sep) ) )
#endif

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)

int yylex(void);
int yyerror(char * errmsg, ...);
int yywarning(char * errmsg, ...);

static int clear_pin(int pinfunc);
static int assign_pin(int pinfunc, TOKEN *v, int invert);
static int assign_pin_list(int invert);
static int which_opcode(TOKEN * opcode);
static int parse_cmdbits(OPCODE * op, int opnum);

static int pin_name;

#line 106 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "config_gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_K_NULL = 3,                     /* K_NULL  */
  YYSYMBOL_K_READ = 4,                     /* K_READ  */
  YYSYMBOL_K_WRITE = 5,                    /* K_WRITE  */
  YYSYMBOL_K_READ_LO = 6,                  /* K_READ_LO  */
  YYSYMBOL_K_READ_HI = 7,                  /* K_READ_HI  */
  YYSYMBOL_K_WRITE_LO = 8,                 /* K_WRITE_LO  */
  YYSYMBOL_K_WRITE_HI = 9,                 /* K_WRITE_HI  */
  YYSYMBOL_K_LOADPAGE_LO = 10,             /* K_LOADPAGE_LO  */
  YYSYMBOL_K_LOADPAGE_HI = 11,             /* K_LOADPAGE_HI  */
  YYSYMBOL_K_LOAD_EXT_ADDR = 12,           /* K_LOAD_EXT_ADDR  */
  YYSYMBOL_K_WRITEPAGE = 13,               /* K_WRITEPAGE  */
  YYSYMBOL_K_CHIP_ERASE = 14,              /* K_CHIP_ERASE  */
  YYSYMBOL_K_PGM_ENABLE = 15,              /* K_PGM_ENABLE  */
  YYSYMBOL_K_MEMORY = 16,                  /* K_MEMORY  */
  YYSYMBOL_K_PAGE_SIZE = 17,               /* K_PAGE_SIZE  */
  YYSYMBOL_K_PAGED = 18,                   /* K_PAGED  */
  YYSYMBOL_K_ALIAS = 19,                   /* K_ALIAS  */
  YYSYMBOL_K_BAUDRATE = 20,                /* K_BAUDRATE  */
  YYSYMBOL_K_BS2 = 21,                     /* K_BS2  */
  YYSYMBOL_K_BUFF = 22,                    /* K_BUFF  */
  YYSYMBOL_K_CHIP_ERASE_DELAY = 23,        /* K_CHIP_ERASE_DELAY  */
  YYSYMBOL_K_CONNTYPE = 24,                /* K_CONNTYPE  */
  YYSYMBOL_K_DEDICATED = 25,               /* K_DEDICATED  */
  YYSYMBOL_K_DEFAULT_BITCLOCK = 26,        /* K_DEFAULT_BITCLOCK  */
  YYSYMBOL_K_DEFAULT_PARALLEL = 27,        /* K_DEFAULT_PARALLEL  */
  YYSYMBOL_K_DEFAULT_PROGRAMMER = 28,      /* K_DEFAULT_PROGRAMMER  */
  YYSYMBOL_K_DEFAULT_SERIAL = 29,          /* K_DEFAULT_SERIAL  */
  YYSYMBOL_K_DEFAULT_SPI = 30,             /* K_DEFAULT_SPI  */
  YYSYMBOL_K_DESC = 31,                    /* K_DESC  */
  YYSYMBOL_K_FAMILY_ID = 32,               /* K_FAMILY_ID  */
  YYSYMBOL_K_HVUPDI_SUPPORT = 33,          /* K_HVUPDI_SUPPORT  */
  YYSYMBOL_K_HVUPDI_VARIANT = 34,          /* K_HVUPDI_VARIANT  */
  YYSYMBOL_K_DEVICECODE = 35,              /* K_DEVICECODE  */
  YYSYMBOL_K_STK500_DEVCODE = 36,          /* K_STK500_DEVCODE  */
  YYSYMBOL_K_AVR910_DEVCODE = 37,          /* K_AVR910_DEVCODE  */
  YYSYMBOL_K_EEPROM = 38,                  /* K_EEPROM  */
  YYSYMBOL_K_ERRLED = 39,                  /* K_ERRLED  */
  YYSYMBOL_K_FLASH = 40,                   /* K_FLASH  */
  YYSYMBOL_K_ID = 41,                      /* K_ID  */
  YYSYMBOL_K_IO = 42,                      /* K_IO  */
  YYSYMBOL_K_LOADPAGE = 43,                /* K_LOADPAGE  */
  YYSYMBOL_K_MAX_WRITE_DELAY = 44,         /* K_MAX_WRITE_DELAY  */
  YYSYMBOL_K_MCU_BASE = 45,                /* K_MCU_BASE  */
  YYSYMBOL_K_MIN_WRITE_DELAY = 46,         /* K_MIN_WRITE_DELAY  */
  YYSYMBOL_K_SDI = 47,                     /* K_SDI  */
  YYSYMBOL_K_SDO = 48,                     /* K_SDO  */
  YYSYMBOL_K_NUM_PAGES = 49,               /* K_NUM_PAGES  */
  YYSYMBOL_K_NVM_BASE = 50,                /* K_NVM_BASE  */
  YYSYMBOL_K_OCD_BASE = 51,                /* K_OCD_BASE  */
  YYSYMBOL_K_OCDREV = 52,                  /* K_OCDREV  */
  YYSYMBOL_K_OFFSET = 53,                  /* K_OFFSET  */
  YYSYMBOL_K_PAGEL = 54,                   /* K_PAGEL  */
  YYSYMBOL_K_PARALLEL = 55,                /* K_PARALLEL  */
  YYSYMBOL_K_PARENT = 56,                  /* K_PARENT  */
  YYSYMBOL_K_PART = 57,                    /* K_PART  */
  YYSYMBOL_K_PGMLED = 58,                  /* K_PGMLED  */
  YYSYMBOL_K_PROGRAMMER = 59,              /* K_PROGRAMMER  */
  YYSYMBOL_K_PSEUDO = 60,                  /* K_PSEUDO  */
  YYSYMBOL_K_PWROFF_AFTER_WRITE = 61,      /* K_PWROFF_AFTER_WRITE  */
  YYSYMBOL_K_RDYLED = 62,                  /* K_RDYLED  */
  YYSYMBOL_K_READBACK = 63,                /* K_READBACK  */
  YYSYMBOL_K_READBACK_P1 = 64,             /* K_READBACK_P1  */
  YYSYMBOL_K_READBACK_P2 = 65,             /* K_READBACK_P2  */
  YYSYMBOL_K_READMEM = 66,                 /* K_READMEM  */
  YYSYMBOL_K_RESET = 67,                   /* K_RESET  */
  YYSYMBOL_K_RETRY_PULSE = 68,             /* K_RETRY_PULSE  */
  YYSYMBOL_K_SERIAL = 69,                  /* K_SERIAL  */
  YYSYMBOL_K_SPI = 70,                     /* K_SPI  */
  YYSYMBOL_K_SCK = 71,                     /* K_SCK  */
  YYSYMBOL_K_SIGNATURE = 72,               /* K_SIGNATURE  */
  YYSYMBOL_K_SIZE = 73,                    /* K_SIZE  */
  YYSYMBOL_K_USB = 74,                     /* K_USB  */
  YYSYMBOL_K_USBDEV = 75,                  /* K_USBDEV  */
  YYSYMBOL_K_USBSN = 76,                   /* K_USBSN  */
  YYSYMBOL_K_USBPID = 77,                  /* K_USBPID  */
  YYSYMBOL_K_USBPRODUCT = 78,              /* K_USBPRODUCT  */
  YYSYMBOL_K_USBVENDOR = 79,               /* K_USBVENDOR  */
  YYSYMBOL_K_USBVID = 80,                  /* K_USBVID  */
  YYSYMBOL_K_TYPE = 81,                    /* K_TYPE  */
  YYSYMBOL_K_VCC = 82,                     /* K_VCC  */
  YYSYMBOL_K_VFYLED = 83,                  /* K_VFYLED  */
  YYSYMBOL_K_NO = 84,                      /* K_NO  */
  YYSYMBOL_K_YES = 85,                     /* K_YES  */
  YYSYMBOL_K_TIMEOUT = 86,                 /* K_TIMEOUT  */
  YYSYMBOL_K_STABDELAY = 87,               /* K_STABDELAY  */
  YYSYMBOL_K_CMDEXEDELAY = 88,             /* K_CMDEXEDELAY  */
  YYSYMBOL_K_HVSPCMDEXEDELAY = 89,         /* K_HVSPCMDEXEDELAY  */
  YYSYMBOL_K_SYNCHLOOPS = 90,              /* K_SYNCHLOOPS  */
  YYSYMBOL_K_BYTEDELAY = 91,               /* K_BYTEDELAY  */
  YYSYMBOL_K_POLLVALUE = 92,               /* K_POLLVALUE  */
  YYSYMBOL_K_POLLINDEX = 93,               /* K_POLLINDEX  */
  YYSYMBOL_K_PREDELAY = 94,                /* K_PREDELAY  */
  YYSYMBOL_K_POSTDELAY = 95,               /* K_POSTDELAY  */
  YYSYMBOL_K_POLLMETHOD = 96,              /* K_POLLMETHOD  */
  YYSYMBOL_K_MODE = 97,                    /* K_MODE  */
  YYSYMBOL_K_DELAY = 98,                   /* K_DELAY  */
  YYSYMBOL_K_BLOCKSIZE = 99,               /* K_BLOCKSIZE  */
  YYSYMBOL_K_READSIZE = 100,               /* K_READSIZE  */
  YYSYMBOL_K_HVENTERSTABDELAY = 101,       /* K_HVENTERSTABDELAY  */
  YYSYMBOL_K_PROGMODEDELAY = 102,          /* K_PROGMODEDELAY  */
  YYSYMBOL_K_LATCHCYCLES = 103,            /* K_LATCHCYCLES  */
  YYSYMBOL_K_TOGGLEVTG = 104,              /* K_TOGGLEVTG  */
  YYSYMBOL_K_POWEROFFDELAY = 105,          /* K_POWEROFFDELAY  */
  YYSYMBOL_K_RESETDELAYMS = 106,           /* K_RESETDELAYMS  */
  YYSYMBOL_K_RESETDELAYUS = 107,           /* K_RESETDELAYUS  */
  YYSYMBOL_K_HVLEAVESTABDELAY = 108,       /* K_HVLEAVESTABDELAY  */
  YYSYMBOL_K_RESETDELAY = 109,             /* K_RESETDELAY  */
  YYSYMBOL_K_SYNCHCYCLES = 110,            /* K_SYNCHCYCLES  */
  YYSYMBOL_K_HVCMDEXEDELAY = 111,          /* K_HVCMDEXEDELAY  */
  YYSYMBOL_K_CHIPERASEPULSEWIDTH = 112,    /* K_CHIPERASEPULSEWIDTH  */
  YYSYMBOL_K_CHIPERASEPOLLTIMEOUT = 113,   /* K_CHIPERASEPOLLTIMEOUT  */
  YYSYMBOL_K_CHIPERASETIME = 114,          /* K_CHIPERASETIME  */
  YYSYMBOL_K_PROGRAMFUSEPULSEWIDTH = 115,  /* K_PROGRAMFUSEPULSEWIDTH  */
  YYSYMBOL_K_PROGRAMFUSEPOLLTIMEOUT = 116, /* K_PROGRAMFUSEPOLLTIMEOUT  */
  YYSYMBOL_K_PROGRAMLOCKPULSEWIDTH = 117,  /* K_PROGRAMLOCKPULSEWIDTH  */
  YYSYMBOL_K_PROGRAMLOCKPOLLTIMEOUT = 118, /* K_PROGRAMLOCKPOLLTIMEOUT  */
  YYSYMBOL_K_PP_CONTROLSTACK = 119,        /* K_PP_CONTROLSTACK  */
  YYSYMBOL_K_HVSP_CONTROLSTACK = 120,      /* K_HVSP_CONTROLSTACK  */
  YYSYMBOL_K_ALLOWFULLPAGEBITSTREAM = 121, /* K_ALLOWFULLPAGEBITSTREAM  */
  YYSYMBOL_K_ENABLEPAGEPROGRAMMING = 122,  /* K_ENABLEPAGEPROGRAMMING  */
  YYSYMBOL_K_HAS_JTAG = 123,               /* K_HAS_JTAG  */
  YYSYMBOL_K_HAS_DW = 124,                 /* K_HAS_DW  */
  YYSYMBOL_K_HAS_PDI = 125,                /* K_HAS_PDI  */
  YYSYMBOL_K_HAS_UPDI = 126,               /* K_HAS_UPDI  */
  YYSYMBOL_K_HAS_TPI = 127,                /* K_HAS_TPI  */
  YYSYMBOL_K_IS_AT90S1200 = 128,           /* K_IS_AT90S1200  */
  YYSYMBOL_K_IS_AVR32 = 129,               /* K_IS_AVR32  */
  YYSYMBOL_K_FLASH_INSTR = 130,            /* K_FLASH_INSTR  */
  YYSYMBOL_K_EEPROM_INSTR = 131,           /* K_EEPROM_INSTR  */
  YYSYMBOL_TKN_COMMA = 132,                /* TKN_COMMA  */
  YYSYMBOL_TKN_EQUAL = 133,                /* TKN_EQUAL  */
  YYSYMBOL_TKN_SEMI = 134,                 /* TKN_SEMI  */
  YYSYMBOL_TKN_LEFT_PAREN = 135,           /* TKN_LEFT_PAREN  */
  YYSYMBOL_TKN_RIGHT_PAREN = 136,          /* TKN_RIGHT_PAREN  */
  YYSYMBOL_TKN_NUMBER = 137,               /* TKN_NUMBER  */
  YYSYMBOL_TKN_NUMBER_REAL = 138,          /* TKN_NUMBER_REAL  */
  YYSYMBOL_TKN_STRING = 139,               /* TKN_STRING  */
  YYSYMBOL_TKN_COMPONENT = 140,            /* TKN_COMPONENT  */
  YYSYMBOL_OP_OR = 141,                    /* OP_OR  */
  YYSYMBOL_OP_XOR = 142,                   /* OP_XOR  */
  YYSYMBOL_OP_AND = 143,                   /* OP_AND  */
  YYSYMBOL_OP_PLUS = 144,                  /* OP_PLUS  */
  YYSYMBOL_OP_MINUS = 145,                 /* OP_MINUS  */
  YYSYMBOL_OP_TIMES = 146,                 /* OP_TIMES  */
  YYSYMBOL_OP_DIVIDE = 147,                /* OP_DIVIDE  */
  YYSYMBOL_OP_MODULO = 148,                /* OP_MODULO  */
  YYSYMBOL_OP_TILDE = 149,                 /* OP_TILDE  */
  YYSYMBOL_UNARY = 150,                    /* UNARY  */
  YYSYMBOL_YYACCEPT = 151,                 /* $accept  */
  YYSYMBOL_number_real = 152,              /* number_real  */
  YYSYMBOL_expr = 153,                     /* expr  */
  YYSYMBOL_numexpr = 154,                  /* numexpr  */
  YYSYMBOL_configuration = 155,            /* configuration  */
  YYSYMBOL_config = 156,                   /* config  */
  YYSYMBOL_def = 157,                      /* def  */
  YYSYMBOL_prog_def = 158,                 /* prog_def  */
  YYSYMBOL_prog_decl = 159,                /* prog_decl  */
  YYSYMBOL_part_def = 160,                 /* part_def  */
  YYSYMBOL_part_decl = 161,                /* part_decl  */
  YYSYMBOL_string_list = 162,              /* string_list  */
  YYSYMBOL_num_list = 163,                 /* num_list  */
  YYSYMBOL_prog_parms = 164,               /* prog_parms  */
  YYSYMBOL_prog_parm = 165,                /* prog_parm  */
  YYSYMBOL_prog_parm_type = 166,           /* prog_parm_type  */
  YYSYMBOL_prog_parm_type_id = 167,        /* prog_parm_type_id  */
  YYSYMBOL_prog_parm_conntype = 168,       /* prog_parm_conntype  */
  YYSYMBOL_prog_parm_conntype_id = 169,    /* prog_parm_conntype_id  */
  YYSYMBOL_prog_parm_usb = 170,            /* prog_parm_usb  */
  YYSYMBOL_usb_pid_list = 171,             /* usb_pid_list  */
  YYSYMBOL_prog_parm_updi = 172,           /* prog_parm_updi  */
  YYSYMBOL_hvupdi_support_list = 173,      /* hvupdi_support_list  */
  YYSYMBOL_pin_number_non_empty = 174,     /* pin_number_non_empty  */
  YYSYMBOL_pin_number = 175,               /* pin_number  */
  YYSYMBOL_pin_list_element = 176,         /* pin_list_element  */
  YYSYMBOL_pin_list_non_empty = 177,       /* pin_list_non_empty  */
  YYSYMBOL_pin_list = 178,                 /* pin_list  */
  YYSYMBOL_prog_parm_pins = 179,           /* prog_parm_pins  */
  YYSYMBOL_180_1 = 180,                    /* $@1  */
  YYSYMBOL_181_2 = 181,                    /* $@2  */
  YYSYMBOL_182_3 = 182,                    /* $@3  */
  YYSYMBOL_183_4 = 183,                    /* $@4  */
  YYSYMBOL_184_5 = 184,                    /* $@5  */
  YYSYMBOL_185_6 = 185,                    /* $@6  */
  YYSYMBOL_186_7 = 186,                    /* $@7  */
  YYSYMBOL_187_8 = 187,                    /* $@8  */
  YYSYMBOL_188_9 = 188,                    /* $@9  */
  YYSYMBOL_189_10 = 189,                   /* $@10  */
  YYSYMBOL_opcode = 190,                   /* opcode  */
  YYSYMBOL_part_parms = 191,               /* part_parms  */
  YYSYMBOL_reset_disposition = 192,        /* reset_disposition  */
  YYSYMBOL_parallel_modes = 193,           /* parallel_modes  */
  YYSYMBOL_retry_lines = 194,              /* retry_lines  */
  YYSYMBOL_part_parm = 195,                /* part_parm  */
  YYSYMBOL_196_11 = 196,                   /* $@11  */
  YYSYMBOL_yesno = 197,                    /* yesno  */
  YYSYMBOL_mem_specs = 198,                /* mem_specs  */
  YYSYMBOL_mem_spec = 199,                 /* mem_spec  */
  YYSYMBOL_mem_alias = 200                 /* mem_alias  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   592

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  151
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  50
/* YYNRULES -- Number of rules.  */
#define YYNRULES  215
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  479

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   405


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   227,   227,   233,   239,   239,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   258,
     259,   263,   264,   269,   271,   273,   278,   283,   288,   293,
     301,   336,   342,   361,   425,   431,   451,   452,   457,   458,
     462,   463,   467,   471,   480,   482,   484,   486,   488,   492,
     498,   502,   506,   516,   524,   528,   529,   530,   531,   535,
     541,   547,   548,   554,   560,   569,   583,   594,   598,   612,
     623,   625,   629,   631,   635,   637,   641,   643,   648,   650,
     654,   654,   655,   655,   656,   656,   657,   657,   658,   658,
     659,   659,   660,   660,   661,   661,   662,   662,   663,   663,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   683,   684,   689,   689,   693,   693,   697,   697,
     701,   705,   711,   717,   723,   729,   737,   744,   751,   762,
     769,   800,   807,   838,   845,   875,   881,   911,   917,   923,
     929,   935,   945,   951,   957,   963,   969,   975,   981,   987,
     993,   999,  1005,  1011,  1017,  1023,  1029,  1035,  1041,  1047,
    1053,  1059,  1065,  1071,  1077,  1083,  1089,  1095,  1101,  1107,
    1113,  1122,  1131,  1140,  1149,  1158,  1168,  1177,  1187,  1197,
    1203,  1209,  1215,  1221,  1231,  1250,  1266,  1265,  1299,  1311,
    1331,  1347,  1347,  1352,  1353,  1354,  1359,  1364,  1370,  1377,
    1387,  1393,  1399,  1405,  1411,  1417,  1425,  1431,  1438,  1444,
    1450,  1456,  1462,  1469,  1489,  1504
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "K_NULL", "K_READ",
  "K_WRITE", "K_READ_LO", "K_READ_HI", "K_WRITE_LO", "K_WRITE_HI",
  "K_LOADPAGE_LO", "K_LOADPAGE_HI", "K_LOAD_EXT_ADDR", "K_WRITEPAGE",
  "K_CHIP_ERASE", "K_PGM_ENABLE", "K_MEMORY", "K_PAGE_SIZE", "K_PAGED",
  "K_ALIAS", "K_BAUDRATE", "K_BS2", "K_BUFF", "K_CHIP_ERASE_DELAY",
  "K_CONNTYPE", "K_DEDICATED", "K_DEFAULT_BITCLOCK", "K_DEFAULT_PARALLEL",
  "K_DEFAULT_PROGRAMMER", "K_DEFAULT_SERIAL", "K_DEFAULT_SPI", "K_DESC",
  "K_FAMILY_ID", "K_HVUPDI_SUPPORT", "K_HVUPDI_VARIANT", "K_DEVICECODE",
  "K_STK500_DEVCODE", "K_AVR910_DEVCODE", "K_EEPROM", "K_ERRLED",
  "K_FLASH", "K_ID", "K_IO", "K_LOADPAGE", "K_MAX_WRITE_DELAY",
  "K_MCU_BASE", "K_MIN_WRITE_DELAY", "K_SDI", "K_SDO", "K_NUM_PAGES",
  "K_NVM_BASE", "K_OCD_BASE", "K_OCDREV", "K_OFFSET", "K_PAGEL",
  "K_PARALLEL", "K_PARENT", "K_PART", "K_PGMLED", "K_PROGRAMMER",
  "K_PSEUDO", "K_PWROFF_AFTER_WRITE", "K_RDYLED", "K_READBACK",
  "K_READBACK_P1", "K_READBACK_P2", "K_READMEM", "K_RESET",
  "K_RETRY_PULSE", "K_SERIAL", "K_SPI", "K_SCK", "K_SIGNATURE", "K_SIZE",
  "K_USB", "K_USBDEV", "K_USBSN", "K_USBPID", "K_USBPRODUCT",
  "K_USBVENDOR", "K_USBVID", "K_TYPE", "K_VCC", "K_VFYLED", "K_NO",
  "K_YES", "K_TIMEOUT", "K_STABDELAY", "K_CMDEXEDELAY",
  "K_HVSPCMDEXEDELAY", "K_SYNCHLOOPS", "K_BYTEDELAY", "K_POLLVALUE",
  "K_POLLINDEX", "K_PREDELAY", "K_POSTDELAY", "K_POLLMETHOD", "K_MODE",
  "K_DELAY", "K_BLOCKSIZE", "K_READSIZE", "K_HVENTERSTABDELAY",
  "K_PROGMODEDELAY", "K_LATCHCYCLES", "K_TOGGLEVTG", "K_POWEROFFDELAY",
  "K_RESETDELAYMS", "K_RESETDELAYUS", "K_HVLEAVESTABDELAY", "K_RESETDELAY",
  "K_SYNCHCYCLES", "K_HVCMDEXEDELAY", "K_CHIPERASEPULSEWIDTH",
  "K_CHIPERASEPOLLTIMEOUT", "K_CHIPERASETIME", "K_PROGRAMFUSEPULSEWIDTH",
  "K_PROGRAMFUSEPOLLTIMEOUT", "K_PROGRAMLOCKPULSEWIDTH",
  "K_PROGRAMLOCKPOLLTIMEOUT", "K_PP_CONTROLSTACK", "K_HVSP_CONTROLSTACK",
  "K_ALLOWFULLPAGEBITSTREAM", "K_ENABLEPAGEPROGRAMMING", "K_HAS_JTAG",
  "K_HAS_DW", "K_HAS_PDI", "K_HAS_UPDI", "K_HAS_TPI", "K_IS_AT90S1200",
  "K_IS_AVR32", "K_FLASH_INSTR", "K_EEPROM_INSTR", "TKN_COMMA",
  "TKN_EQUAL", "TKN_SEMI", "TKN_LEFT_PAREN", "TKN_RIGHT_PAREN",
  "TKN_NUMBER", "TKN_NUMBER_REAL", "TKN_STRING", "TKN_COMPONENT", "OP_OR",
  "OP_XOR", "OP_AND", "OP_PLUS", "OP_MINUS", "OP_TIMES", "OP_DIVIDE",
  "OP_MODULO", "OP_TILDE", "UNARY", "$accept", "number_real", "expr",
  "numexpr", "configuration", "config", "def", "prog_def", "prog_decl",
  "part_def", "part_decl", "string_list", "num_list", "prog_parms",
  "prog_parm", "prog_parm_type", "prog_parm_type_id", "prog_parm_conntype",
  "prog_parm_conntype_id", "prog_parm_usb", "usb_pid_list",
  "prog_parm_updi", "hvupdi_support_list", "pin_number_non_empty",
  "pin_number", "pin_list_element", "pin_list_non_empty", "pin_list",
  "prog_parm_pins", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "opcode", "part_parms", "reset_disposition",
  "parallel_modes", "retry_lines", "part_parm", "$@11", "yesno",
  "mem_specs", "mem_spec", "mem_alias", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-287)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      -3,  -126,  -119,  -100,   -88,   -78,     1,     3,    61,    -3,
    -287,   -70,    27,   -69,   271,   -66,   -63,   -58,   -52,   -51,
     -49,   -46,  -287,  -287,  -287,   -60,   -38,   -36,   -16,   -12,
      -8,    -6,    -4,    -2,    -1,     2,     6,    11,    14,    28,
      29,    41,    42,    43,    44,    75,    80,    83,    27,   -64,
    -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,
    -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,   -21,    91,
      92,    94,    95,   105,   107,   108,   110,   111,   112,   117,
     119,   120,   155,   156,   157,   158,   160,   171,   176,   177,
     178,   180,   181,   182,   185,   186,   187,   191,   200,   201,
     202,   203,   204,   208,   209,   211,   212,   213,   214,   216,
     217,   218,   219,   220,   221,   222,   223,   235,   236,   237,
     270,   272,   273,   274,   275,   277,   279,   280,   281,   282,
     284,   285,   271,   -14,   102,  -287,  -287,   102,   102,   102,
       4,   121,    76,   183,   289,   290,  -287,  -287,   102,  -287,
      -7,    -9,   102,  -287,   265,  -287,  -287,  -287,  -287,  -287,
    -287,   307,   311,   102,   312,   313,   102,    17,  -287,  -287,
     -53,   319,  -287,   321,   102,   102,   316,   329,   102,   102,
     102,   102,   332,   102,   102,   102,   102,   102,   -41,   -13,
     -54,   -32,   -11,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   102,
     102,   102,     5,     8,   -32,   -32,   -32,   -32,   -32,   -32,
     -32,   -32,   -32,    74,    77,   -53,     7,   338,  -287,   113,
    -287,  -287,  -287,  -287,   102,   102,   102,   102,   102,   102,
     102,   102,  -287,  -287,  -287,  -287,   121,  -128,  -287,  -287,
    -287,  -287,  -287,  -287,   121,     9,  -117,  -287,   341,  -117,
    -117,  -117,  -117,  -117,  -117,  -287,  -287,   121,   343,  -287,
    -287,   121,  -287,  -287,  -287,  -128,  -117,  -287,  -287,   121,
    -287,   133,   430,   121,   121,  -287,  -287,   121,   121,   121,
     121,  -287,   121,   121,   121,   121,   121,  -287,  -287,  -287,
    -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,   340,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,  -287,
     121,   346,  -287,   346,  -287,  -287,  -287,  -287,  -287,  -287,
    -287,  -287,  -287,  -287,   346,  -287,   346,  -287,  -287,   341,
    -287,  -287,   153,   184,   126,   -47,   -47,  -287,  -287,  -287,
    -287,  -107,  -287,  -287,   348,  -287,   102,   344,  -287,  -287,
     345,  -287,  -287,  -287,  -287,  -287,  -287,   102,  -287,  -287,
    -287,   349,   352,   347,   354,   355,   356,   357,   359,   364,
     366,   367,   369,   371,   373,   374,   375,   376,   377,   378,
     452,   380,   384,   382,   102,   102,  -287,  -128,   121,  -287,
     121,   102,   -32,  -287,   102,   102,   102,   102,   -32,   383,
     102,   102,   102,   102,   102,   102,   102,   102,   -53,    19,
     387,  -287,  -287,  -287,   121,   -86,  -287,   121,  -287,   121,
     121,   121,   121,  -287,   385,   121,   121,   121,   121,   121,
     121,   121,   121,  -287,  -287,   341,  -287,  -287,  -287
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      19,     0,     0,     0,     0,     0,    34,    31,     0,    20,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     1,    22,    23,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,     0,
      44,    47,    46,    50,    45,    24,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     6,     3,     0,     0,     0,
       0,     2,     0,     0,     0,     0,    35,    32,     0,    82,
       0,     0,     0,    92,     0,    90,    88,    96,    94,    84,
      86,     0,     0,     0,     0,     0,     0,     0,    80,    98,
       0,     0,    40,   186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   112,     0,
      15,    16,    17,    29,     0,     0,     0,     0,     0,     0,
       0,     0,    26,    25,    27,    28,    49,    79,    55,    56,
      58,    57,    54,    48,    68,    67,    73,    36,    43,    73,
      73,    73,    73,    73,    73,    59,    62,    65,    61,    64,
      63,    60,    53,    52,    51,    79,    73,     5,    42,     4,
      41,     0,     0,   140,   138,   122,   123,   124,   125,   126,
     127,   121,   179,   180,   181,   182,   139,   117,   192,   191,
     184,   116,   114,   115,   141,   118,   119,   185,   183,     0,
     129,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   169,   162,   163,   164,   165,   166,   167,   168,   131,
      38,   130,   133,   132,   177,   178,   170,   171,   172,   173,
     174,   175,   176,   135,   134,   137,   136,   120,   190,   189,
     113,    18,     7,     8,     9,    10,    11,    12,    13,    14,
      70,     0,    74,    76,    78,    83,     0,     0,    72,    93,
       0,    91,    89,    97,    95,    85,    87,     0,    81,    99,
     188,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     187,     0,     0,     0,     0,     0,    71,     0,    69,    37,
      66,     0,     0,   215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,   128,    39,     0,    77,   199,   197,   203,
     202,   200,   201,   204,     0,   206,   207,   198,   212,   208,
     209,   210,   211,   196,   214,   213,   195,    75,   205
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -287,  -287,  -233,   -15,  -287,  -287,   503,  -287,  -287,  -287,
    -287,  -232,  -218,  -287,   476,  -287,  -287,  -287,  -287,  -287,
    -287,  -287,  -287,  -254,  -158,    99,  -287,   246,  -287,  -287,
    -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,  -287,  -286,
    -287,  -287,  -287,  -287,   400,  -287,  -190,  -287,   114,  -287
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   140,   288,   350,     8,     9,    10,    11,    12,    13,
      14,   268,   351,    48,    49,    50,   284,    51,   262,    52,
     278,    53,   265,   388,   389,   383,   384,   385,    54,   285,
     257,   273,   274,   270,   269,   266,   272,   271,   286,   131,
     132,   314,   310,   317,   133,   292,   311,   420,   421,   422
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     141,   318,   367,   382,   369,   353,   419,    15,   349,   380,
     368,   352,   312,   315,    16,   364,   366,   316,   282,   307,
     380,   381,   474,     1,     2,     3,     4,     5,   425,   313,
     426,   382,   387,    17,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   308,   309,    18,   424,    25,   258,    26,
     477,    27,   308,   309,     6,    19,     7,    20,    28,    21,
      29,    22,   259,   260,    24,    55,    30,   261,    31,   134,
     172,   135,   136,   148,    32,    33,   142,   363,   137,   138,
     365,   143,   134,   139,   135,    34,   287,   144,   145,    35,
     146,   137,   138,   147,    36,   149,   139,   150,    37,   249,
     250,   251,    38,    39,    40,    41,    42,    43,    44,    45,
      46,   391,   392,   393,   394,   395,   396,   151,   173,   239,
     238,   152,   240,   241,   242,   153,   319,   154,   399,   155,
     263,   156,   157,   256,   419,   158,   400,   264,   243,   159,
     134,   386,   135,   134,   160,   135,   267,   161,   277,   137,
     138,   281,   137,   138,   139,   289,   283,   139,   267,   293,
     294,   162,   163,   297,   298,   299,   300,    47,   302,   303,
     304,   305,   306,   382,   164,   165,   166,   167,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   455,   168,   134,
     252,   135,   134,   169,   135,   473,   170,   475,   137,   138,
     289,   137,   138,   139,   174,   175,   139,   176,   177,   372,
     373,   374,   375,   376,   377,   378,   379,   134,   178,   135,
     179,   180,   458,   181,   182,   183,   137,   138,   463,   371,
     184,   139,   185,   186,   244,   245,   246,   247,   248,   249,
     250,   251,   244,   245,   246,   247,   248,   249,   250,   251,
     247,   248,   249,   250,   251,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,   187,   188,
     189,   190,    69,   191,    70,   245,   246,   247,   248,   249,
     250,   251,    71,    72,   192,    73,    74,    75,    76,   193,
     194,   195,    77,   196,   197,   198,    78,   253,   199,   200,
     201,    79,    80,    81,   202,    82,    83,   246,   247,   248,
     249,   250,   251,   203,   204,   205,   206,   207,    84,    85,
      86,   208,   209,    87,   210,   211,   212,   213,    88,   214,
     215,   216,   217,   218,   219,   220,   221,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   222,   223,
     224,   428,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   430,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   225,   267,   226,   227,   228,   229,   454,
     230,   130,   231,   232,   233,   234,   457,   235,   236,   459,
     460,   461,   462,   254,   255,   465,   466,   467,   468,   469,
     470,   471,   472,   289,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,   275,   401,   402,   403,
     276,   279,   280,   290,   291,   295,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,   296,   401,
     402,   301,   370,   390,   404,   397,   405,   423,   424,   406,
     427,   426,   431,   407,   429,   432,   433,   434,   435,   436,
     437,   408,   438,   409,   410,   411,   404,   439,   405,   440,
     441,   406,   442,   412,   443,   407,   444,   445,   446,   447,
     448,   449,    23,   408,   451,   409,   410,   411,   452,   453,
     464,   476,   478,   413,   171,   412,   456,   414,   415,   416,
     417,   398,   237,     0,   450,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   413,     0,     0,     0,   414,
     415,   416,   417,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     418,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   418
};

static const yytype_int16 yycheck[] =
{
      15,   191,   235,   257,   236,   223,   292,   133,     3,   137,
       3,     3,    25,    67,   133,   233,   234,    71,     1,    60,
     137,   149,     3,    26,    27,    28,    29,    30,   135,    42,
     137,   285,   149,   133,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    84,    85,   133,   132,    20,    55,    22,
     136,    24,    84,    85,    57,   133,    59,    56,    31,    56,
      33,     0,    69,    70,   134,   134,    39,    74,    41,   135,
     134,   137,   138,   133,    47,    48,   139,     3,   144,   145,
       3,   139,   135,   149,   137,    58,   139,   139,   139,    62,
     139,   144,   145,   139,    67,   133,   149,   133,    71,   146,
     147,   148,    75,    76,    77,    78,    79,    80,    81,    82,
      83,   269,   270,   271,   272,   273,   274,   133,   139,   134,
     134,   133,   137,   138,   139,   133,   137,   133,   286,   133,
     139,   133,   133,   148,   420,   133,     3,   152,   134,   133,
     135,   132,   137,   135,   133,   137,   139,   133,   163,   144,
     145,   166,   144,   145,   149,   170,   139,   149,   139,   174,
     175,   133,   133,   178,   179,   180,   181,   140,   183,   184,
     185,   186,   187,   427,   133,   133,   133,   133,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   425,   133,   135,
     134,   137,   135,   133,   137,   448,   133,   449,   144,   145,
     235,   144,   145,   149,   133,   133,   149,   133,   133,   244,
     245,   246,   247,   248,   249,   250,   251,   135,   133,   137,
     133,   133,   432,   133,   133,   133,   144,   145,   438,   136,
     133,   149,   133,   133,   141,   142,   143,   144,   145,   146,
     147,   148,   141,   142,   143,   144,   145,   146,   147,   148,
     144,   145,   146,   147,   148,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,   133,   133,
     133,   133,    21,   133,    23,   142,   143,   144,   145,   146,
     147,   148,    31,    32,   133,    34,    35,    36,    37,   133,
     133,   133,    41,   133,   133,   133,    45,   134,   133,   133,
     133,    50,    51,    52,   133,    54,    55,   143,   144,   145,
     146,   147,   148,   133,   133,   133,   133,   133,    67,    68,
      69,   133,   133,    72,   133,   133,   133,   133,    77,   133,
     133,   133,   133,   133,   133,   133,   133,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,   133,   133,
     133,   386,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   397,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   133,   139,   133,   133,   133,   133,   424,
     133,   140,   133,   133,   133,   133,   431,   133,   133,   434,
     435,   436,   437,   134,   134,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,   139,    17,    18,    19,
     139,   139,   139,   134,   133,   139,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,   139,    17,
      18,   139,   134,   132,    44,   132,    46,   137,   132,    49,
     132,   137,   133,    53,   139,   133,   139,   133,   133,   133,
     133,    61,   133,    63,    64,    65,    44,   133,    46,   133,
     133,    49,   133,    73,   133,    53,   133,   133,   133,   133,
     133,   133,     9,    61,   134,    63,    64,    65,   134,   137,
     137,   134,   137,    93,    48,    73,   427,    97,    98,    99,
     100,   285,   132,    -1,   420,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,
      98,    99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   140
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    26,    27,    28,    29,    30,    57,    59,   155,   156,
     157,   158,   159,   160,   161,   133,   133,   133,   133,   133,
      56,    56,     0,   157,   134,    20,    22,    24,    31,    33,
      39,    41,    47,    48,    58,    62,    67,    71,    75,    76,
      77,    78,    79,    80,    81,    82,    83,   140,   164,   165,
     166,   168,   170,   172,   179,   134,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    21,
      23,    31,    32,    34,    35,    36,    37,    41,    45,    50,
      51,    52,    54,    55,    67,    68,    69,    72,    77,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     140,   190,   191,   195,   135,   137,   138,   144,   145,   149,
     152,   154,   139,   139,   139,   139,   139,   139,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   165,   134,   139,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   195,   134,   154,
     154,   154,   154,   134,   141,   142,   143,   144,   145,   146,
     147,   148,   134,   134,   134,   134,   154,   181,    55,    69,
      70,    74,   169,   139,   154,   173,   186,   139,   162,   185,
     184,   188,   187,   182,   183,   139,   139,   154,   171,   139,
     139,   154,     1,   139,   167,   180,   189,   139,   153,   154,
     134,   133,   196,   154,   154,   139,   139,   154,   154,   154,
     154,   139,   154,   154,   154,   154,   154,    60,    84,    85,
     193,   197,    25,    42,   192,    67,    71,   194,   197,   137,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,     3,
     154,   163,     3,   163,   197,   197,   197,   197,   197,   197,
     197,   197,   197,     3,   163,     3,   163,   153,     3,   162,
     134,   136,   154,   154,   154,   154,   154,   154,   154,   154,
     137,   149,   174,   176,   177,   178,   132,   149,   174,   175,
     132,   175,   175,   175,   175,   175,   175,   132,   178,   175,
       3,    17,    18,    19,    44,    46,    49,    53,    61,    63,
      64,    65,    73,    93,    97,    98,    99,   100,   140,   190,
     198,   199,   200,   137,   132,   135,   137,   132,   154,   139,
     154,   133,   133,   139,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     199,   134,   134,   137,   154,   163,   176,   154,   197,   154,
     154,   154,   154,   197,   137,   154,   154,   154,   154,   154,
     154,   154,   154,   153,     3,   162,   134,   136,   137
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   151,   152,   152,   153,   153,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   155,
     155,   156,   156,   157,   157,   157,   157,   157,   157,   157,
     158,   159,   159,   160,   161,   161,   162,   162,   163,   163,
     164,   164,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   166,   167,   167,   168,   169,   169,   169,   169,   170,
     170,   170,   170,   170,   170,   171,   171,   172,   173,   173,
     174,   174,   175,   175,   176,   176,   177,   177,   178,   178,
     180,   179,   181,   179,   182,   179,   183,   179,   184,   179,
     185,   179,   186,   179,   187,   179,   188,   179,   189,   179,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   191,   191,   192,   192,   193,   193,   194,   194,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   196,   195,   195,   195,
     195,   197,   197,   198,   198,   198,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   200
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     3,     0,
       1,     1,     2,     2,     2,     4,     4,     4,     4,     4,
       2,     1,     3,     2,     1,     3,     1,     3,     1,     3,
       2,     3,     3,     3,     1,     1,     1,     1,     3,     3,
       1,     3,     1,     1,     3,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     2,     1,     0,     1,     4,     1,     3,     1,     0,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     0,     4,     4,     3,
       3,     1,     1,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* number_real: numexpr  */
#line 227 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
         {
    yyval = yyvsp[0];
    /* convert value to real */
    yyval->value.number_real = yyval->value.number;
    yyval->value.type = V_NUM_REAL;
  }
#line 1672 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 3: /* number_real: TKN_NUMBER_REAL  */
#line 233 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                  {
    yyval = yyvsp[0];
  }
#line 1680 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 7: /* numexpr: numexpr OP_OR numexpr  */
#line 243 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number |= yyvsp[0]->value.number; }
#line 1686 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 8: /* numexpr: numexpr OP_XOR numexpr  */
#line 244 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number ^= yyvsp[0]->value.number; }
#line 1692 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 9: /* numexpr: numexpr OP_AND numexpr  */
#line 245 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number &= yyvsp[0]->value.number; }
#line 1698 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 10: /* numexpr: numexpr OP_PLUS numexpr  */
#line 246 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number += yyvsp[0]->value.number; }
#line 1704 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 11: /* numexpr: numexpr OP_MINUS numexpr  */
#line 247 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number -= yyvsp[0]->value.number; }
#line 1710 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 12: /* numexpr: numexpr OP_TIMES numexpr  */
#line 248 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number *= yyvsp[0]->value.number; }
#line 1716 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 13: /* numexpr: numexpr OP_DIVIDE numexpr  */
#line 249 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number /= yyvsp[0]->value.number; }
#line 1722 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 14: /* numexpr: numexpr OP_MODULO numexpr  */
#line 250 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            { yyval = yyvsp[-2]; yyval->value.number %= yyvsp[0]->value.number; }
#line 1728 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 15: /* numexpr: OP_PLUS numexpr  */
#line 251 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               { yyval = yyvsp[0]; }
#line 1734 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 16: /* numexpr: OP_MINUS numexpr  */
#line 252 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               { yyval = yyvsp[0]; yyval->value.number = -yyval->value.number; }
#line 1740 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 17: /* numexpr: OP_TILDE numexpr  */
#line 253 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               { yyval = yyvsp[0]; yyval->value.number = ~yyval->value.number; }
#line 1746 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 18: /* numexpr: TKN_LEFT_PAREN numexpr TKN_RIGHT_PAREN  */
#line 254 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                         { yyval = yyvsp[-1]; }
#line 1752 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 25: /* def: K_DEFAULT_PROGRAMMER TKN_EQUAL TKN_STRING TKN_SEMI  */
#line 273 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                     {
    default_programmer = cache_string(yyvsp[-1]->value.string);
    free_token(yyvsp[-1]);
  }
#line 1761 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 26: /* def: K_DEFAULT_PARALLEL TKN_EQUAL TKN_STRING TKN_SEMI  */
#line 278 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                   {
    default_parallel = cache_string(yyvsp[-1]->value.string);
    free_token(yyvsp[-1]);
  }
#line 1770 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 27: /* def: K_DEFAULT_SERIAL TKN_EQUAL TKN_STRING TKN_SEMI  */
#line 283 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                 {
    default_serial = cache_string(yyvsp[-1]->value.string);
    free_token(yyvsp[-1]);
  }
#line 1779 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 28: /* def: K_DEFAULT_SPI TKN_EQUAL TKN_STRING TKN_SEMI  */
#line 288 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                              {
    default_spi = cache_string(yyvsp[-1]->value.string);
    free_token(yyvsp[-1]);
  }
#line 1788 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 29: /* def: K_DEFAULT_BITCLOCK TKN_EQUAL number_real TKN_SEMI  */
#line 293 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                    {
    default_bitclock = yyvsp[-1]->value.number_real;
    free_token(yyvsp[-1]);
  }
#line 1797 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 30: /* prog_def: prog_decl prog_parms  */
#line 302 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      PROGRAMMER * existing_prog;
      char * id;
      if (lsize(current_prog->id) == 0) {
        yyerror("required parameter id not specified");
        YYABORT;
      }
      if (current_prog->initpgm == NULL) {
        yyerror("programmer type not specified");
        YYABORT;
      }
      id = ldata(lfirst(current_prog->id));
      existing_prog = locate_programmer(programmers, id);
      if (existing_prog) {
        { /* temporarily set lineno to lineno of programmer start */
          int temp = cfg_lineno; cfg_lineno = current_prog->lineno;
          yywarning("programmer %s overwrites previous definition %s:%d.",
                id, existing_prog->config_file, existing_prog->lineno);
          cfg_lineno = temp;
        }
        lrmv_d(programmers, existing_prog);
        pgm_free(existing_prog);
      }
      current_prog->comments = cfg_move_comments();
      LISTADD(programmers, current_prog);
//      pgm_fill_old_pins(current_prog); // TODO to be removed if old pin data no longer needed
//      pgm_display_generic(current_prog, id);
      current_prog = NULL;
      current_strct = COMP_CONFIG_MAIN;
    }
#line 1832 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 31: /* prog_decl: K_PROGRAMMER  */
#line 337 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    { current_prog = pgm_new();
      current_prog->config_file = cache_string(cfg_infile);
      current_prog->lineno = cfg_lineno;
    }
#line 1841 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 32: /* prog_decl: K_PROGRAMMER K_PARENT TKN_STRING  */
#line 343 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      PROGRAMMER * pgm = locate_programmer(programmers, yyvsp[0]->value.string);
      if (pgm == NULL) {
        yyerror("parent programmer %s not found", yyvsp[0]->value.string);
        free_token(yyvsp[0]);
        YYABORT;
      }
      current_prog = pgm_dup(pgm);
      current_prog->parent_id = cache_string(yyvsp[0]->value.string);
      current_prog->comments = NULL;
      current_prog->config_file = cache_string(cfg_infile);
      current_prog->lineno = cfg_lineno;
      free_token(yyvsp[0]);
    }
#line 1860 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 33: /* part_def: part_decl part_parms  */
#line 362 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    { 
      LNODEID ln;
      AVRMEM * m;
      AVRPART * existing_part;

      if (current_part->id[0] == 0) {
        yyerror("required parameter id not specified");
        YYABORT;
      }

      cfg_update_mcuid(current_part);

      // Sanity checks for memory sizes and compute/override num_pages entry
      for (ln=lfirst(current_part->mem); ln; ln=lnext(ln)) {
        m = ldata(ln);
        if (m->paged) {
          if (m->size <= 0) {
            yyerror("must specify a positive size for paged memory %s", m->desc);
            YYABORT;
          }
          if (m->page_size <= 0) {
            yyerror("must specify a positive page size for paged memory %s", m->desc);
            YYABORT;
          }
          // Code base relies on page_size being a power of 2 in some places
          if (m->page_size & (m->page_size - 1)) {
            yyerror("page size must be a power of 2 for paged memory %s", m->desc);
            YYABORT;
          }
          // Code base relies on size being a multiple of page_size
          if (m->size % m->page_size) {
            yyerror("size must be a multiple of page size for paged memory %s", m->desc);
            YYABORT;
          }
          // Warn if num_pages was specified but is inconsistent with size and page size
          if (m->num_pages && m->num_pages != m->size / m->page_size)
            yywarning("overriding num_page to be %d for memory %s", m->size/m->page_size, m->desc);

          m->num_pages = m->size / m->page_size;
        }
      }

      existing_part = locate_part(part_list, current_part->id);
      if (existing_part) {
        { /* temporarily set lineno to lineno of part start */
          int temp = cfg_lineno; cfg_lineno = current_part->lineno;
          yywarning("part %s overwrites previous definition %s:%d.",
                current_part->id,
                existing_part->config_file, existing_part->lineno);
          cfg_lineno = temp;
        }
        lrmv_d(part_list, existing_part);
        avr_free_part(existing_part);
      }

      current_part->comments = cfg_move_comments();
      LISTADD(part_list, current_part); 
      current_part = NULL; 
      current_strct = COMP_CONFIG_MAIN;
    }
#line 1925 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 34: /* part_decl: K_PART  */
#line 426 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part = avr_new_part();
      current_part->config_file = cache_string(cfg_infile);
      current_part->lineno = cfg_lineno;
    }
#line 1935 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 35: /* part_decl: K_PART K_PARENT TKN_STRING  */
#line 432 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      AVRPART * parent_part = locate_part(part_list, yyvsp[0]->value.string);
      if (parent_part == NULL) {
        yyerror("can't find parent part");
        free_token(yyvsp[0]);
        YYABORT;
      }

      current_part = avr_dup_part(parent_part);
      current_part->parent_id = cache_string(yyvsp[0]->value.string);
      current_part->comments = NULL;
      current_part->config_file = cache_string(cfg_infile);
      current_part->lineno = cfg_lineno;

      free_token(yyvsp[0]);
    }
#line 1956 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 36: /* string_list: TKN_STRING  */
#line 451 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
             { ladd(string_list, yyvsp[0]); }
#line 1962 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 37: /* string_list: string_list TKN_COMMA TKN_STRING  */
#line 452 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                   { ladd(string_list, yyvsp[0]); }
#line 1968 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 38: /* num_list: numexpr  */
#line 457 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
          { ladd(number_list, yyvsp[0]); }
#line 1974 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 39: /* num_list: num_list TKN_COMMA numexpr  */
#line 458 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                             { ladd(number_list, yyvsp[0]); }
#line 1980 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 42: /* prog_parm: TKN_COMPONENT TKN_EQUAL expr  */
#line 467 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    cfg_assign((char *) current_prog, COMP_PROGRAMMER, yyvsp[-2]->value.comp, &yyvsp[0]->value);
    free_token(yyvsp[-2]);
  }
#line 1989 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 43: /* prog_parm: K_ID TKN_EQUAL string_list  */
#line 471 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                             {
    {
      while (lsize(string_list)) {
        TOKEN *t = lrmv_n(string_list, 1);
        ladd(current_prog->id, cfg_strdup("config_gram.y", t->value.string));
        free_token(t);
      }
    }
  }
#line 2003 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 48: /* prog_parm: K_DESC TKN_EQUAL TKN_STRING  */
#line 488 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                              {
    current_prog->desc = cache_string(yyvsp[0]->value.string);
    free_token(yyvsp[0]);
  }
#line 2012 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 49: /* prog_parm: K_BAUDRATE TKN_EQUAL numexpr  */
#line 492 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    {
      current_prog->baudrate = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
  }
#line 2023 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 52: /* prog_parm_type_id: TKN_STRING  */
#line 506 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                    {
  const struct programmer_type_t * pgm_type = locate_programmer_type(yyvsp[0]->value.string);
    if (pgm_type == NULL) {
        yyerror("programmer type %s not found", yyvsp[0]->value.string);
        free_token(yyvsp[0]); 
        YYABORT;
    }
    current_prog->initpgm = pgm_type->initpgm;
    free_token(yyvsp[0]); 
}
#line 2038 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 53: /* prog_parm_type_id: error  */
#line 517 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
{
        yyerror("programmer type must be written as \"id_type\"");
        YYABORT;
}
#line 2047 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 55: /* prog_parm_conntype_id: K_PARALLEL  */
#line 528 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                    { current_prog->conntype = CONNTYPE_PARALLEL; }
#line 2053 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 56: /* prog_parm_conntype_id: K_SERIAL  */
#line 529 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                    { current_prog->conntype = CONNTYPE_SERIAL; }
#line 2059 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 57: /* prog_parm_conntype_id: K_USB  */
#line 530 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                    { current_prog->conntype = CONNTYPE_USB; }
#line 2065 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 58: /* prog_parm_conntype_id: K_SPI  */
#line 531 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                    { current_prog->conntype = CONNTYPE_SPI; }
#line 2071 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 59: /* prog_parm_usb: K_USBDEV TKN_EQUAL TKN_STRING  */
#line 535 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                {
    {
      current_prog->usbdev = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
  }
#line 2082 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 60: /* prog_parm_usb: K_USBVID TKN_EQUAL numexpr  */
#line 541 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                             {
    {
      current_prog->usbvid = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
  }
#line 2093 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 62: /* prog_parm_usb: K_USBSN TKN_EQUAL TKN_STRING  */
#line 548 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    {
      current_prog->usbsn = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
  }
#line 2104 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 63: /* prog_parm_usb: K_USBVENDOR TKN_EQUAL TKN_STRING  */
#line 554 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                   {
    {
      current_prog->usbvendor = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
  }
#line 2115 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 64: /* prog_parm_usb: K_USBPRODUCT TKN_EQUAL TKN_STRING  */
#line 560 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                    {
    {
      current_prog->usbproduct = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
  }
#line 2126 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 65: /* usb_pid_list: numexpr  */
#line 569 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
          {
    {
      /* overwrite pids, so clear the existing entries */
      if(current_prog->usbpid)
        ldestroy_cb(current_prog->usbpid, free);
      current_prog->usbpid = lcreat(NULL, 0);
    }
    {
      int *ip = cfg_malloc("usb_pid_list", sizeof(int));
      *ip = yyvsp[0]->value.number;
      ladd(current_prog->usbpid, ip);
      free_token(yyvsp[0]);
    }
  }
#line 2145 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 66: /* usb_pid_list: usb_pid_list TKN_COMMA numexpr  */
#line 583 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                 {
    {
      int *ip = cfg_malloc("usb_pid_list", sizeof(int));
      *ip = yyvsp[0]->value.number;
      ladd(current_prog->usbpid, ip);
      free_token(yyvsp[0]);
    }
  }
#line 2158 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 68: /* hvupdi_support_list: numexpr  */
#line 598 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
          {
    {
      /* overwrite list entries, so clear the existing entries */
      if(current_prog->hvupdi_support)
        ldestroy_cb(current_prog->hvupdi_support, free);
      current_prog->hvupdi_support = lcreat(NULL, 0);
    }
    {
      int *ip = cfg_malloc("hvupdi_support_list", sizeof(int));
      *ip = yyvsp[0]->value.number;
      ladd(current_prog->hvupdi_support, ip);
      free_token(yyvsp[0]);
    }
  }
#line 2177 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 69: /* hvupdi_support_list: hvupdi_support_list TKN_COMMA numexpr  */
#line 612 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                        {
    {
      int *ip = cfg_malloc("hvupdi_support_list", sizeof(int));
      *ip = yyvsp[0]->value.number;
      ladd(current_prog->hvupdi_support, ip);
      free_token(yyvsp[0]);
    }
  }
#line 2190 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 70: /* pin_number_non_empty: TKN_NUMBER  */
#line 623 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
             { if(0 != assign_pin(pin_name, yyvsp[0], 0)) YYABORT;  }
#line 2196 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 71: /* pin_number_non_empty: OP_TILDE TKN_NUMBER  */
#line 625 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                      { if(0 != assign_pin(pin_name, yyvsp[0], 1)) YYABORT; }
#line 2202 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 73: /* pin_number: %empty  */
#line 631 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
              { pin_clear_all(&(current_prog->pin[pin_name])); }
#line 2208 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 75: /* pin_list_element: OP_TILDE TKN_LEFT_PAREN num_list TKN_RIGHT_PAREN  */
#line 637 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                   { if(0 != assign_pin_list(1)) YYABORT; }
#line 2214 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 79: /* pin_list: %empty  */
#line 650 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
              { pin_clear_all(&(current_prog->pin[pin_name])); }
#line 2220 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 80: /* $@1: %empty  */
#line 654 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PPI_AVR_VCC; clear_pin(pin_name);  }
#line 2226 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 82: /* $@2: %empty  */
#line 655 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PPI_AVR_BUFF; clear_pin(pin_name); }
#line 2232 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 84: /* $@3: %empty  */
#line 656 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_AVR_RESET; clear_pin(pin_name);}
#line 2238 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 85: /* prog_parm_pins: K_RESET TKN_EQUAL $@3 pin_number  */
#line 656 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                                                 { free_token(yyvsp[-3]); }
#line 2244 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 86: /* $@4: %empty  */
#line 657 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_AVR_SCK; clear_pin(pin_name);  }
#line 2250 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 87: /* prog_parm_pins: K_SCK TKN_EQUAL $@4 pin_number  */
#line 657 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                                                 { free_token(yyvsp[-3]); }
#line 2256 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 88: /* $@5: %empty  */
#line 658 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_AVR_SDO; clear_pin(pin_name);  }
#line 2262 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 90: /* $@6: %empty  */
#line 659 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_AVR_SDI; clear_pin(pin_name);  }
#line 2268 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 92: /* $@7: %empty  */
#line 660 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_LED_ERR; clear_pin(pin_name);  }
#line 2274 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 94: /* $@8: %empty  */
#line 661 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_LED_RDY; clear_pin(pin_name);  }
#line 2280 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 96: /* $@9: %empty  */
#line 662 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_LED_PGM; clear_pin(pin_name);  }
#line 2286 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 98: /* $@10: %empty  */
#line 663 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                     {pin_name = PIN_LED_VFY; clear_pin(pin_name);  }
#line 2292 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 120: /* part_parm: TKN_COMPONENT TKN_EQUAL expr  */
#line 701 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    cfg_assign((char *) current_part, COMP_AVRPART, yyvsp[-2]->value.comp, &yyvsp[0]->value);
    free_token(yyvsp[-2]);
  }
#line 2301 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 121: /* part_parm: K_ID TKN_EQUAL TKN_STRING  */
#line 706 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->id = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
#line 2310 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 122: /* part_parm: K_DESC TKN_EQUAL TKN_STRING  */
#line 712 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->desc = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
#line 2319 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 123: /* part_parm: K_FAMILY_ID TKN_EQUAL TKN_STRING  */
#line 718 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->family_id = cache_string(yyvsp[0]->value.string);
      free_token(yyvsp[0]);
    }
#line 2328 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 124: /* part_parm: K_HVUPDI_VARIANT TKN_EQUAL numexpr  */
#line 724 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->hvupdi_variant = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2337 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 125: /* part_parm: K_DEVICECODE TKN_EQUAL numexpr  */
#line 729 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                 {
    {
      yyerror("devicecode is deprecated, use "
              "stk500_devcode instead");
      YYABORT;
    }
  }
#line 2349 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 126: /* part_parm: K_STK500_DEVCODE TKN_EQUAL numexpr  */
#line 737 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                     {
    {
      current_part->stk500_devcode = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
  }
#line 2360 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 127: /* part_parm: K_AVR910_DEVCODE TKN_EQUAL numexpr  */
#line 744 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                     {
    {
      current_part->avr910_devcode = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
  }
#line 2371 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 128: /* part_parm: K_SIGNATURE TKN_EQUAL TKN_NUMBER TKN_NUMBER TKN_NUMBER  */
#line 751 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                                         {
    {
      current_part->signature[0] = yyvsp[-2]->value.number;
      current_part->signature[1] = yyvsp[-1]->value.number;
      current_part->signature[2] = yyvsp[0]->value.number;
      free_token(yyvsp[-2]);
      free_token(yyvsp[-1]);
      free_token(yyvsp[0]);
    }
  }
#line 2386 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 129: /* part_parm: K_USBPID TKN_EQUAL numexpr  */
#line 762 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                            {
    {
      current_part->usbpid = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
  }
#line 2397 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 130: /* part_parm: K_PP_CONTROLSTACK TKN_EQUAL num_list  */
#line 769 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                       {
    {
      TOKEN * t;
      unsigned nbytes;
      int ok;

      current_part->ctl_stack_type = CTL_STACK_PP;
      nbytes = 0;
      ok = 1;

      memset(current_part->controlstack, 0, CTL_STACK_SIZE);
      while (lsize(number_list)) {
        t = lrmv_n(number_list, 1);
	if (nbytes < CTL_STACK_SIZE)
	  {
	    current_part->controlstack[nbytes] = t->value.number;
	    nbytes++;
	  }
	else
	  {
	    ok = 0;
	  }
        free_token(t);
      }
      if (!ok)
	{
	  yywarning("too many bytes in control stack");
        }
    }
  }
#line 2432 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 131: /* part_parm: K_PP_CONTROLSTACK TKN_EQUAL K_NULL  */
#line 800 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                     {
    {
      current_part->ctl_stack_type = CTL_STACK_NONE;
      memset(current_part->controlstack, 0, CTL_STACK_SIZE);
    }
  }
#line 2443 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 132: /* part_parm: K_HVSP_CONTROLSTACK TKN_EQUAL num_list  */
#line 807 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                         {
    {
      TOKEN * t;
      unsigned nbytes;
      int ok;

      current_part->ctl_stack_type = CTL_STACK_HVSP;
      nbytes = 0;
      ok = 1;

      memset(current_part->controlstack, 0, CTL_STACK_SIZE);
      while (lsize(number_list)) {
        t = lrmv_n(number_list, 1);
	if (nbytes < CTL_STACK_SIZE)
	  {
	    current_part->controlstack[nbytes] = t->value.number;
	    nbytes++;
	  }
	else
	  {
	    ok = 0;
	  }
        free_token(t);
      }
      if (!ok)
	{
	  yywarning("too many bytes in control stack");
        }
    }
  }
#line 2478 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 133: /* part_parm: K_HVSP_CONTROLSTACK TKN_EQUAL K_NULL  */
#line 838 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                       {
    {
      current_part->ctl_stack_type = CTL_STACK_NONE;
      memset(current_part->controlstack, 0, CTL_STACK_SIZE);
    }
  }
#line 2489 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 134: /* part_parm: K_FLASH_INSTR TKN_EQUAL num_list  */
#line 845 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                   {
    {
      TOKEN * t;
      unsigned nbytes;
      int ok;

      nbytes = 0;
      ok = 1;

      memset(current_part->flash_instr, 0, FLASH_INSTR_SIZE);
      while (lsize(number_list)) {
        t = lrmv_n(number_list, 1);
	if (nbytes < FLASH_INSTR_SIZE)
	  {
	    current_part->flash_instr[nbytes] = t->value.number;
	    nbytes++;
	  }
	else
	  {
	    ok = 0;
	  }
        free_token(t);
      }
      if (!ok)
	{
	  yywarning("too many bytes in flash instructions");
        }
    }
  }
#line 2523 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 135: /* part_parm: K_FLASH_INSTR TKN_EQUAL K_NULL  */
#line 875 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                 {
    {
      memset(current_part->flash_instr, 0, FLASH_INSTR_SIZE);
    }
  }
#line 2533 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 136: /* part_parm: K_EEPROM_INSTR TKN_EQUAL num_list  */
#line 881 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                    {
    {
      TOKEN * t;
      unsigned nbytes;
      int ok;

      nbytes = 0;
      ok = 1;

      memset(current_part->eeprom_instr, 0, EEPROM_INSTR_SIZE);
      while (lsize(number_list)) {
        t = lrmv_n(number_list, 1);
	if (nbytes < EEPROM_INSTR_SIZE)
	  {
	    current_part->eeprom_instr[nbytes] = t->value.number;
	    nbytes++;
	  }
	else
	  {
	    ok = 0;
	  }
        free_token(t);
      }
      if (!ok)
	{
	  yywarning("too many bytes in EEPROM instructions");
        }
    }
  }
#line 2567 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 137: /* part_parm: K_EEPROM_INSTR TKN_EQUAL K_NULL  */
#line 911 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                                  {
    {
      memset(current_part->eeprom_instr, 0, EEPROM_INSTR_SIZE);
    }
  }
#line 2577 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 138: /* part_parm: K_CHIP_ERASE_DELAY TKN_EQUAL numexpr  */
#line 918 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->chip_erase_delay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2586 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 139: /* part_parm: K_PAGEL TKN_EQUAL numexpr  */
#line 924 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->pagel = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2595 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 140: /* part_parm: K_BS2 TKN_EQUAL numexpr  */
#line 930 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->bs2 = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2604 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 141: /* part_parm: K_RESET TKN_EQUAL reset_disposition  */
#line 936 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_DEDICATED)
        current_part->reset_disposition = RESET_DEDICATED;
      else if (yyvsp[0]->primary == K_IO)
        current_part->reset_disposition = RESET_IO;

      free_tokens(2, yyvsp[-2], yyvsp[0]);
    }
#line 2617 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 142: /* part_parm: K_TIMEOUT TKN_EQUAL numexpr  */
#line 946 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->timeout = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2626 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 143: /* part_parm: K_STABDELAY TKN_EQUAL numexpr  */
#line 952 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->stabdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2635 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 144: /* part_parm: K_CMDEXEDELAY TKN_EQUAL numexpr  */
#line 958 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->cmdexedelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2644 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 145: /* part_parm: K_HVSPCMDEXEDELAY TKN_EQUAL numexpr  */
#line 964 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->hvspcmdexedelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2653 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 146: /* part_parm: K_SYNCHLOOPS TKN_EQUAL numexpr  */
#line 970 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->synchloops = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2662 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 147: /* part_parm: K_BYTEDELAY TKN_EQUAL numexpr  */
#line 976 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->bytedelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2671 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 148: /* part_parm: K_POLLVALUE TKN_EQUAL numexpr  */
#line 982 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->pollvalue = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2680 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 149: /* part_parm: K_POLLINDEX TKN_EQUAL numexpr  */
#line 988 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->pollindex = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2689 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 150: /* part_parm: K_PREDELAY TKN_EQUAL numexpr  */
#line 994 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->predelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2698 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 151: /* part_parm: K_POSTDELAY TKN_EQUAL numexpr  */
#line 1000 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->postdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2707 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 152: /* part_parm: K_POLLMETHOD TKN_EQUAL numexpr  */
#line 1006 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->pollmethod = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2716 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 153: /* part_parm: K_HVENTERSTABDELAY TKN_EQUAL numexpr  */
#line 1012 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->hventerstabdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2725 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 154: /* part_parm: K_PROGMODEDELAY TKN_EQUAL numexpr  */
#line 1018 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->progmodedelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2734 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 155: /* part_parm: K_LATCHCYCLES TKN_EQUAL numexpr  */
#line 1024 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->latchcycles = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2743 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 156: /* part_parm: K_TOGGLEVTG TKN_EQUAL numexpr  */
#line 1030 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->togglevtg = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2752 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 157: /* part_parm: K_POWEROFFDELAY TKN_EQUAL numexpr  */
#line 1036 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->poweroffdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2761 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 158: /* part_parm: K_RESETDELAYMS TKN_EQUAL numexpr  */
#line 1042 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->resetdelayms = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2770 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 159: /* part_parm: K_RESETDELAYUS TKN_EQUAL numexpr  */
#line 1048 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->resetdelayus = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2779 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 160: /* part_parm: K_HVLEAVESTABDELAY TKN_EQUAL numexpr  */
#line 1054 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->hvleavestabdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2788 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 161: /* part_parm: K_RESETDELAY TKN_EQUAL numexpr  */
#line 1060 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->resetdelay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2797 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 162: /* part_parm: K_CHIPERASEPULSEWIDTH TKN_EQUAL numexpr  */
#line 1066 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->chiperasepulsewidth = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2806 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 163: /* part_parm: K_CHIPERASEPOLLTIMEOUT TKN_EQUAL numexpr  */
#line 1072 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->chiperasepolltimeout = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2815 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 164: /* part_parm: K_CHIPERASETIME TKN_EQUAL numexpr  */
#line 1078 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->chiperasetime = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2824 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 165: /* part_parm: K_PROGRAMFUSEPULSEWIDTH TKN_EQUAL numexpr  */
#line 1084 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->programfusepulsewidth = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2833 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 166: /* part_parm: K_PROGRAMFUSEPOLLTIMEOUT TKN_EQUAL numexpr  */
#line 1090 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->programfusepolltimeout = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2842 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 167: /* part_parm: K_PROGRAMLOCKPULSEWIDTH TKN_EQUAL numexpr  */
#line 1096 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->programlockpulsewidth = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2851 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 168: /* part_parm: K_PROGRAMLOCKPOLLTIMEOUT TKN_EQUAL numexpr  */
#line 1102 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->programlockpolltimeout = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2860 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 169: /* part_parm: K_SYNCHCYCLES TKN_EQUAL numexpr  */
#line 1108 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->synchcycles = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2869 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 170: /* part_parm: K_HAS_JTAG TKN_EQUAL yesno  */
#line 1114 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_JTAG;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~(PM_JTAG | PM_JTAGmkI | PM_XMEGAJTAG | PM_AVR32JTAG);
      free_token(yyvsp[0]);
    }
#line 2881 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 171: /* part_parm: K_HAS_DW TKN_EQUAL yesno  */
#line 1123 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_debugWIRE;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~PM_debugWIRE;
      free_token(yyvsp[0]);
    }
#line 2893 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 172: /* part_parm: K_HAS_PDI TKN_EQUAL yesno  */
#line 1132 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_PDI;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~PM_PDI;
      free_token(yyvsp[0]);
    }
#line 2905 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 173: /* part_parm: K_HAS_UPDI TKN_EQUAL yesno  */
#line 1141 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_UPDI;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~PM_UPDI;
      free_token(yyvsp[0]);
    }
#line 2917 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 174: /* part_parm: K_HAS_TPI TKN_EQUAL yesno  */
#line 1150 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_TPI;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~PM_TPI;
      free_token(yyvsp[0]);
    }
#line 2929 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 175: /* part_parm: K_IS_AT90S1200 TKN_EQUAL yesno  */
#line 1159 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->flags |= AVRPART_IS_AT90S1200;
      else if (yyvsp[0]->primary == K_NO)
        current_part->flags &= ~AVRPART_IS_AT90S1200;

      free_token(yyvsp[0]);
    }
#line 2942 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 176: /* part_parm: K_IS_AVR32 TKN_EQUAL yesno  */
#line 1169 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->prog_modes |= PM_aWire;
      else if (yyvsp[0]->primary == K_NO)
        current_part->prog_modes &= ~PM_aWire;
      free_token(yyvsp[0]);
    }
#line 2954 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 177: /* part_parm: K_ALLOWFULLPAGEBITSTREAM TKN_EQUAL yesno  */
#line 1178 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->flags |= AVRPART_ALLOWFULLPAGEBITSTREAM;
      else if (yyvsp[0]->primary == K_NO)
        current_part->flags &= ~AVRPART_ALLOWFULLPAGEBITSTREAM;

      free_token(yyvsp[0]);
    }
#line 2967 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 178: /* part_parm: K_ENABLEPAGEPROGRAMMING TKN_EQUAL yesno  */
#line 1188 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->flags |= AVRPART_ENABLEPAGEPROGRAMMING;
      else if (yyvsp[0]->primary == K_NO)
        current_part->flags &= ~AVRPART_ENABLEPAGEPROGRAMMING;

      free_token(yyvsp[0]);
    }
#line 2980 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 179: /* part_parm: K_MCU_BASE TKN_EQUAL numexpr  */
#line 1198 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->mcu_base = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2989 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 180: /* part_parm: K_NVM_BASE TKN_EQUAL numexpr  */
#line 1204 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->nvm_base = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 2998 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 181: /* part_parm: K_OCD_BASE TKN_EQUAL numexpr  */
#line 1210 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->ocd_base = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3007 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 182: /* part_parm: K_OCDREV TKN_EQUAL numexpr  */
#line 1216 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_part->ocdrev = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3016 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 183: /* part_parm: K_SERIAL TKN_EQUAL yesno  */
#line 1222 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES)
        current_part->flags |= AVRPART_SERIALOK;
      else if (yyvsp[0]->primary == K_NO)
        current_part->flags &= ~AVRPART_SERIALOK;

      free_token(yyvsp[0]);
    }
#line 3029 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 184: /* part_parm: K_PARALLEL TKN_EQUAL parallel_modes  */
#line 1232 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (yyvsp[0]->primary == K_YES) {
        current_part->flags |= AVRPART_PARALLELOK;
        current_part->flags &= ~AVRPART_PSEUDOPARALLEL;
      }
      else if (yyvsp[0]->primary == K_NO) {
        current_part->flags &= ~AVRPART_PARALLELOK;
        current_part->flags &= ~AVRPART_PSEUDOPARALLEL;
      }
      else if (yyvsp[0]->primary == K_PSEUDO) {
        current_part->flags |= AVRPART_PARALLELOK;
        current_part->flags |= AVRPART_PSEUDOPARALLEL;
      }


      free_token(yyvsp[0]);
    }
#line 3051 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 185: /* part_parm: K_RETRY_PULSE TKN_EQUAL retry_lines  */
#line 1251 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      switch (yyvsp[0]->primary) {
        case K_RESET :
          current_part->retry_pulse = PIN_AVR_RESET;
          break;
        case K_SCK :
          current_part->retry_pulse = PIN_AVR_SCK;
          break;
      }

      free_token(yyvsp[-2]);
    }
#line 3068 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 186: /* $@11: %empty  */
#line 1266 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    { /* select memory for extension or create if not there */
      AVRMEM *mem = avr_locate_mem_noalias(current_part, yyvsp[0]->value.string);
      if(!mem) {
        mem = avr_new_memtype();
        mem->desc = cache_string(yyvsp[0]->value.string);
        ladd(current_part->mem, mem);
      }
      avr_add_mem_order(yyvsp[0]->value.string);
      current_mem = mem;
      free_token(yyvsp[0]);
    }
#line 3084 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 187: /* part_parm: K_MEMORY TKN_STRING $@11 mem_specs  */
#line 1278 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      if (is_alias) {           // alias mem has been already entered
        lrmv_d(current_part->mem, current_mem);
        avr_free_mem(current_mem);
        is_alias = false;
      } else {                  // check all opcodes re necessary address bits
        unsigned char cmd[4] = { 0, 0, 0, 0, };
        int bn;

        for(int i=0; i<AVR_OP_MAX; i++)
          if(current_mem && current_mem->op[i]) {
            if((bn = avr_set_addr_mem(current_mem, i, cmd, 0UL)) > 0)
              yywarning("%s's %s %s misses a necessary address bit a%d",
                 current_part->desc, current_mem->desc, opcodename(i), bn-1);
            }
        current_mem->comments = cfg_move_comments();
      }
      cfg_pop_comms();
      current_mem = NULL; 
      current_strct = COMP_AVRPART;
    }
#line 3110 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 188: /* part_parm: K_MEMORY TKN_STRING TKN_EQUAL K_NULL  */
#line 1300 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
   {
      AVRMEM *existing_mem = avr_locate_mem_noalias(current_part, yyvsp[-2]->value.string);
      if (existing_mem != NULL) {
        lrmv_d(current_part->mem, existing_mem);
        avr_free_mem(existing_mem);
      }
      free_token(yyvsp[-2]);
      cfg_pop_comms();
      current_mem = NULL;
      current_strct = COMP_AVRPART;
    }
#line 3126 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 189: /* part_parm: opcode TKN_EQUAL string_list  */
#line 1311 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    { 
      int opnum;
      OPCODE * op;

      opnum = which_opcode(yyvsp[-2]);
      if (opnum < 0) YYABORT;
      op = avr_new_opcode();
      if(0 != parse_cmdbits(op, opnum))
        YYABORT;
      if (current_part->op[opnum] != NULL) {
        /*yywarning("operation redefined");*/
        avr_free_opcode(current_part->op[opnum]);
      }
      current_part->op[opnum] = op;

      free_token(yyvsp[-2]);
    }
  }
#line 3150 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 190: /* part_parm: opcode TKN_EQUAL K_NULL  */
#line 1331 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                          {
    {
      int opnum = which_opcode(yyvsp[-2]);
      if(opnum < 0)
         YYABORT;
      if(current_part->op[opnum] != NULL)
        avr_free_opcode(current_part->op[opnum]);
      current_part->op[opnum] = NULL;

      free_token(yyvsp[-2]);
    }
  }
#line 3167 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 196: /* mem_spec: TKN_COMPONENT TKN_EQUAL expr  */
#line 1359 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    cfg_assign((char *) current_mem, COMP_AVRMEM, yyvsp[-2]->value.comp, &yyvsp[0]->value);
    free_token(yyvsp[-2]);
  }
#line 3176 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 197: /* mem_spec: K_PAGED TKN_EQUAL yesno  */
#line 1365 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->paged = yyvsp[0]->primary == K_YES ? 1 : 0;
      free_token(yyvsp[0]);
    }
#line 3185 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 198: /* mem_spec: K_SIZE TKN_EQUAL numexpr  */
#line 1371 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->size = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3194 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 199: /* mem_spec: K_PAGE_SIZE TKN_EQUAL numexpr  */
#line 1378 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      int ps = yyvsp[0]->value.number;
      if (ps <= 0)
        pmsg_warning("invalid page size %d, ignored [%s:%d]\n", ps, cfg_infile, cfg_lineno);
      else
        current_mem->page_size = ps;
      free_token(yyvsp[0]);
    }
#line 3207 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 200: /* mem_spec: K_NUM_PAGES TKN_EQUAL numexpr  */
#line 1388 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->num_pages = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3216 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 201: /* mem_spec: K_OFFSET TKN_EQUAL numexpr  */
#line 1394 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->offset = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3225 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 202: /* mem_spec: K_MIN_WRITE_DELAY TKN_EQUAL numexpr  */
#line 1400 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->min_write_delay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3234 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 203: /* mem_spec: K_MAX_WRITE_DELAY TKN_EQUAL numexpr  */
#line 1406 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->max_write_delay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3243 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 204: /* mem_spec: K_PWROFF_AFTER_WRITE TKN_EQUAL yesno  */
#line 1412 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->pwroff_after_write = yyvsp[0]->primary == K_YES ? 1 : 0;
      free_token(yyvsp[0]);
    }
#line 3252 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 205: /* mem_spec: K_READBACK TKN_EQUAL TKN_NUMBER TKN_NUMBER  */
#line 1418 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->readback[0] = yyvsp[-1]->value.number;
      current_mem->readback[1] = yyvsp[0]->value.number;
      free_token(yyvsp[-1]);
      free_token(yyvsp[0]);
    }
#line 3263 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 206: /* mem_spec: K_READBACK_P1 TKN_EQUAL numexpr  */
#line 1426 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->readback[0] = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3272 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 207: /* mem_spec: K_READBACK_P2 TKN_EQUAL numexpr  */
#line 1432 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->readback[1] = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3281 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 208: /* mem_spec: K_MODE TKN_EQUAL numexpr  */
#line 1439 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->mode = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3290 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 209: /* mem_spec: K_DELAY TKN_EQUAL numexpr  */
#line 1445 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->delay = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3299 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 210: /* mem_spec: K_BLOCKSIZE TKN_EQUAL numexpr  */
#line 1451 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->blocksize = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3308 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 211: /* mem_spec: K_READSIZE TKN_EQUAL numexpr  */
#line 1457 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->readsize = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3317 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 212: /* mem_spec: K_POLLINDEX TKN_EQUAL numexpr  */
#line 1463 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
    {
      current_mem->pollindex = yyvsp[0]->value.number;
      free_token(yyvsp[0]);
    }
#line 3326 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 213: /* mem_spec: opcode TKN_EQUAL string_list  */
#line 1469 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                               {
    { 
      int opnum;
      OPCODE * op;

      opnum = which_opcode(yyvsp[-2]);
      if (opnum < 0) YYABORT;
      op = avr_new_opcode();
      if(0 != parse_cmdbits(op, opnum))
        YYABORT;
      if (current_mem->op[opnum] != NULL) {
        /*yywarning("operation redefined");*/
        avr_free_opcode(current_mem->op[opnum]);
      }
      current_mem->op[opnum] = op;

      free_token(yyvsp[-2]);
    }
  }
#line 3350 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 214: /* mem_spec: opcode TKN_EQUAL K_NULL  */
#line 1489 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
                          {
    {
      int opnum = which_opcode(yyvsp[-2]);
      if(opnum < 0)
         YYABORT;
      if(current_mem->op[opnum] != NULL)
        avr_free_opcode(current_mem->op[opnum]);
      current_mem->op[opnum] = NULL;

      free_token(yyvsp[-2]);
    }
  }
#line 3367 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;

  case 215: /* mem_alias: K_ALIAS TKN_STRING  */
#line 1505 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"
  {
      AVRMEM * existing_mem;

      existing_mem = avr_locate_mem(current_part, yyvsp[0]->value.string);
      if (existing_mem == NULL) {
        yyerror("%s alias to non-existent memory %s",
                current_mem->desc, yyvsp[0]->value.string);
        free_token(yyvsp[0]);
        YYABORT;
      }

      // if this alias does already exist, drop the old one
      AVRMEM_ALIAS * alias = avr_locate_memalias(current_part, current_mem->desc);
      if (alias) {
        lrmv_d(current_part->mem_alias, alias);
        avr_free_memalias(alias);
      }

      is_alias = true;
      alias = avr_new_memalias();
      alias->desc = current_mem->desc;
      alias->aliased_mem = existing_mem;
      ladd(current_part->mem_alias, alias);

      free_token(yyvsp[0]);
  }
#line 3398 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"
    break;


#line 3402 "/build/avrdude/src/avrdude-7.1/build/config_gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1533 "/build/avrdude/src/avrdude-7.1/src/config_gram.y"


#if 0
static char * vtypestr(int type)
{
  switch (type) {
    case V_NUM : return "INTEGER";
    case V_NUM_REAL: return "REAL";
    case V_STR : return "STRING";
    default:
      return "<UNKNOWN>";
  }
}
#endif


static int clear_pin(int pinfunc) {
  if(pinfunc < 0 || pinfunc >= N_PINS) {
    yyerror("pin function must be in the range [0, %d]", N_PINS-1);
    return -1;
  }

  pin_clear_all(&(current_prog->pin[pinfunc]));

  return 0;
}

static int assign_pin(int pinfunc, TOKEN *v, int invert) {
  if(pinfunc < 0 || pinfunc >= N_PINS) {
    yyerror("pin function must be in the range [0, %d]", N_PINS-1);
    return -1;
  }

  int value = v->value.number;
  free_token(v);

  if ((value < PIN_MIN) || (value > PIN_MAX)) {
    yyerror("pin must be in the range " TOSTRING(PIN_MIN) "-"  TOSTRING(PIN_MAX));
    return -1;
  }

  pin_set_value(&(current_prog->pin[pinfunc]), value, invert);

  return 0;
}

static int assign_pin_list(int invert)
{
  TOKEN * t;
  int pin;
  int rv = 0;

  if(pin_name < 0 || pin_name >= N_PINS) {
    yyerror("pin_name should be in the range [0, %d]", N_PINS-1);
    return -1;
  }

  current_prog->pinno[pin_name] = NO_PIN;
  while (lsize(number_list)) {
    t = lrmv_n(number_list, 1);
    if (rv == 0) {
      pin = t->value.number;
      if ((pin < PIN_MIN) || (pin > PIN_MAX)) {
        yyerror("pin must be in the range " TOSTRING(PIN_MIN) "-"  TOSTRING(PIN_MAX));
        rv = -1;
      /* loop clears list and frees tokens */
      }
      pin_set_value(&(current_prog->pin[pin_name]), pin, invert);
    }
    free_token(t);
  }
  return rv;
}

static int which_opcode(TOKEN * opcode)
{
  switch (opcode->primary) {
    case K_READ        : return AVR_OP_READ; break;
    case K_WRITE       : return AVR_OP_WRITE; break;
    case K_READ_LO     : return AVR_OP_READ_LO; break;
    case K_READ_HI     : return AVR_OP_READ_HI; break;
    case K_WRITE_LO    : return AVR_OP_WRITE_LO; break;
    case K_WRITE_HI    : return AVR_OP_WRITE_HI; break;
    case K_LOADPAGE_LO : return AVR_OP_LOADPAGE_LO; break;
    case K_LOADPAGE_HI : return AVR_OP_LOADPAGE_HI; break;
    case K_LOAD_EXT_ADDR : return AVR_OP_LOAD_EXT_ADDR; break;
    case K_WRITEPAGE   : return AVR_OP_WRITEPAGE; break;
    case K_CHIP_ERASE  : return AVR_OP_CHIP_ERASE; break;
    case K_PGM_ENABLE  : return AVR_OP_PGM_ENABLE; break;
    default :
      yyerror("invalid opcode");
      return -1;
      break;
  }
}


static int parse_cmdbits(OPCODE * op, int opnum)
{
  TOKEN *t;
  int bitno;
  int len;
  char *s, *brkt = NULL;
  int rv = 0;

  bitno = 32;
  while (lsize(string_list)) {

    t = lrmv_n(string_list, 1);

    char *str = t->value.string;
    // Compact alternative specification? (eg, "0100.0000--000x.xxxx--xxaa.aaaa--iiii.iiii")
    char bit[2] = {0, 0}, *cc = str;
    int compact = !strchr(str, ' ') && strlen(str) > 7;

    bit[0] = *cc++;
    s = !compact? strtok_r(str, " ", &brkt): *bit? bit: NULL;
    while (rv == 0 && s != NULL) {

      // Ignore visual grouping characters in compact mode
      if(*s != '.' && *s != '-' && *s != '_' && *s !='/')
        bitno--;
      if (bitno < 0) {
        yyerror("too many opcode bits for instruction");
        rv = -1;
        break;
      }

      len = strlen(s);

      if (len == 0) {
        yyerror("invalid bit specifier \"\"");
        rv = -1;
        break;
      }

      if (len == 1) {
        switch (*s) {
          case '1':
            op->bit[bitno].type  = AVR_CMDBIT_VALUE;
            op->bit[bitno].value = 1;
            op->bit[bitno].bitno = bitno % 8;
            break;
          case '0':
            op->bit[bitno].type  = AVR_CMDBIT_VALUE;
            op->bit[bitno].value = 0;
            op->bit[bitno].bitno = bitno % 8;
            break;
          case 'x':
            op->bit[bitno].type  = AVR_CMDBIT_IGNORE;
            op->bit[bitno].value = 0;
            op->bit[bitno].bitno = bitno % 8;
            break;
          case 'a':
            op->bit[bitno].type  = AVR_CMDBIT_ADDRESS;
            op->bit[bitno].value = 0;
            op->bit[bitno].bitno = bitno < 8 || bitno > 23? 0:
              opnum == AVR_OP_LOAD_EXT_ADDR? bitno+8: bitno-8; /* correct bit number for lone 'a' */
            if(bitno < 8 || bitno > 23)
              yywarning("address bits don't normally appear in Bytes 0 or 3 of SPI commands");
            break;
          case 'i':
            op->bit[bitno].type  = AVR_CMDBIT_INPUT;
            op->bit[bitno].value = 0;
            op->bit[bitno].bitno = bitno % 8;
            break;
          case 'o':
            op->bit[bitno].type  = AVR_CMDBIT_OUTPUT;
            op->bit[bitno].value = 0;
            op->bit[bitno].bitno = bitno % 8;
            break;
          case '.':
          case '-':
          case '_':
          case '/':
            break;
          default :
            yyerror("invalid bit specifier '%c'", *s);
            rv = -1;
            break;
        }
      }
      else {
        if (*s == 'a') {
          int sb, bn;
          char *e, *q;

          q = s+1;
          errno = 0;
          bn = strtol(q, &e, 0); // address line
          if (e == q || *e != 0 || errno) {
            yywarning("can't parse bit number from a%s", q);
            bn = 0;
          }

          sb = opnum == AVR_OP_LOAD_EXT_ADDR? bitno+8: bitno-8; // should be this number
          if(bitno < 8 || bitno > 23)
            yywarning("address bits don't normally appear in Bytes 0 or 3 of SPI commands");
          else if((bn & 31) != sb)
            yywarning("a%d would normally be expected to be a%d", bn, sb);
          else if(bn < 0 || bn > 31)
            yywarning("invalid address bit a%d, using a%d", bn, bn & 31);

          op->bit[bitno].bitno = bn & 31;

          op->bit[bitno].type = AVR_CMDBIT_ADDRESS;
          op->bit[bitno].value = 0;
        }
        else {
          yyerror("invalid bit specifier %s", s);
          rv = -1;
          break;
        }
      }

      bit[0] = *cc++;
      s = !compact? strtok_r(NULL, " ", &brkt): *bit? bit: NULL;
    } /* while */

    free_token(t);

  }  /* while */

  if(bitno > 0)
    yywarning("too few opcode bits in instruction");

  return rv;
}
